;;;                                            (acht-damen-2012.scm)
;;;                                Albowski , 2'2012
(load "laufzeiten.scm")
;;; 
;;; Gute HG+T
;;; -----------------------------------------------------------------
(require (lib "breakpoint.ss"))

;;; ===== Nachfolger ================================================
; Die Nachfolgerfunktion generiert nur die zulaessigen Felder
; zwischen 1 und der Anzahl der Spalten.
(define
  (Nachfolger Damen Index)
  (cond
    [(zero? Index) '()]
    [(member Index Damen) (Nachfolger Damen (- Index 1))]
    [(diagonal-besetzt? (cons Index Damen))
     (Nachfolger Damen (- Index 1))]
    [else
     (cons Index (Nachfolger Damen (- Index 1)))]))

;;; ===== diagonal-besetzt? =========================================
; Testet die Diagonalen.
; Damen: Liste der Spaltenindizes der jetzt gesetzten Damen.
; Verwendet die Hilfsfunktion diagonal-hilfe?
(define
  (diagonal-besetzt? Damen)
  (diagonal-hilfe? (first  Damen) (rest Damen) 1))
(define
  (diagonal-hilfe? Dame Damen Zeile)
  (cond
    [(null? Damen) #f]
    [(= (+ Dame Zeile) (first Damen)) #t]
    [(= (- Dame Zeile) (first Damen)) #t]
    [else
     (diagonal-hilfe? Dame (rest Damen) (+ Zeile 1))]))


;;; ===== Tiefensuche ===============================================
; Das eigentliche Tiefensuche-Programm
; verwendet die Hilfsfunktion ts
; und zur Zeitmessung die Funktion [mit Zustand=OO] Zeit
; und zur grafischen Darstellung die Funktion Darstellung
(define
  (Tiefensuche max-Zahl)
  (Zeit 'start)
  (ts (Nachfolger '() max-Zahl) '() max-Zahl))
(define
  (ts Alternativen Damen max-Zahl)
  (cond
    [(= (length Damen) max-Zahl)
     (writeln (Zeit 'miss))
     (Darstellung Damen)
     Damen]
    [(null? Alternativen) #f]      
    [(ts
      (Nachfolger (cons (first Alternativen) Damen) max-Zahl)
      (cons (first Alternativen) Damen)
      max-Zahl)]
    [else
     (ts
      (rest Alternativen)
      Damen
      max-Zahl)]))

;;; ===== Darstellung ===============================================
(define
  (Darstellung Damen)
  (let loop
    ((Anzahl (length Damen))
     (Damen Damen))
    (cond
      ((null? Damen) (newline))
      (else
       (stelle-Zeile-dar Anzahl (first Damen))
       (loop Anzahl (rest Damen))))))

;;; ===== stelle-Zeile-dar ==========================================
(define
  (stelle-Zeile-dar Anzahl Spalte)
  (let loop
    ((Index 1))
    (cond
      ((> Index Anzahl) (newline))
      ((= Index Spalte) 
       (display " D ")
       (loop (add1 Index)))
      (else
       (display " * ")
       (loop (add1 Index))))))

;;;  4 -->     0 ms
;;;  5 -->    10 ms
;;;  6 -->    10 ms
;;;  7 -->     0 ms
;;;  8 -->    30 ms
;;;  9 -->    10 ms
;;; 10 -->    20 ms
;;; 11 -->      30 ms
;;; 12 -->     110 ms
;;; 13 -->      50 ms
;;; 14 -->     901 ms
;;; 15 -->     751 ms
;;; 16 -->    5718 ms
;;; 17 -->    3395 ms
;;; 18 -->   28190 ms
;;; 19 -->    1912 ms
;;; 20 -->  156485 ms =  2 min 36 s 485 ms
;;; 21 -->    7631 ms
;;; 22 --> 1585430 ms = 26 min 25 s 430 ms
;;; 23 -->   26979 ms
;;; 24 -->   ???
;;; 25 -->   61389 ms
;;; 26 -->   ???
;;; 27 -->  635404 ms = 10 min 35 s 404 ms
;;; =================================================================
(Tiefensuche 8)
